//******************************************************************************
// File Name            : led_control_ram.v
//------------------------------------------------------------------------------
// Function             : led_control with RAM
//                        
//------------------------------------------------------------------------------
// Designer             : yokomizo@himwari_co 
//------------------------------------------------------------------------------
// History
// 1.00  2010/10/6
//******************************************************************************
module led_control_ram ( clk, push_sw, led_0);
  input clk;    //clk 40MHz
  input push_sw;   //reset 0:reset 
  output led_0; //led control 0:on 1:off
  reg  push_sw_dff1;
  reg  push_sw_dff2;
  reg  push_sw_dff3;
  reg  push_sw_dff4;
  reg  push_sw_fall; //push_sw茟o
  wire init_sig;     //M
  reg  rec_sig;      //ω^C~OL^M
  reg  mem_mode ;    //L^[h:1 \[h:0
  reg  led_0;          //LED䃌WX^ 
  reg  [7:0] mem_cnt;  //L^
  wire [7:0] mem_adr;  //AhX
  wire [31:0] mem_wd;  //݃f[^
  reg  [31:0] led_cnt; //LED_^C~OJEg
  wire [31:0] led_cnt_max;//LED_^C~OJEgől
   
  parameter  df_max = 32'd120000000; //for FPGA
  //parameter  df_max = 32'd40000; //for sim

//XCb`͂̃^Xe[u΍       
always @ (posedge clk )begin
    begin
      push_sw_dff1 <= push_sw ;
      push_sw_dff2 <= push_sw_dff1 ;
      push_sw_dff3 <= push_sw_dff2 ;
      push_sw_dff4 <= push_sw_dff3 ;
    end
end
   
//͐M̗茟o@JE^M
always @ (posedge clk )begin
 if ((push_sw_dff3 == 1'b1)&&(push_sw_dff2==1'b0))
    push_sw_fall <= 1'b1;
  else
    push_sw_fall <= 1'b0;
end

//L^[h   
always @ (posedge clk )begin
  if (push_sw_dff3==1'b0)
    //push_swXCb`ꂽꍇɋL^[hֈڍs
    mem_mode <= 1'b1;
  else if((mem_mode==1'b1)&&(led_cnt == df_max))
    //df_maxpush_swXCb`Ȃꍇɕ\[hֈڍs
    mem_mode <= 1'b0;
  else
    mem_mode <= mem_mode;
end

//\[hpush_swXCb`ꂽꍇ͏
assign init_sig = ((push_sw_fall==1'b1)&&(mem_mode==1'b0))?1'b1:1'b0;

//push_sw̒lωꍇɋL^   
always @ (posedge clk  )begin
  if (push_sw_dff4 != push_sw_dff3)
    rec_sig <= 1'b1;
  else
    rec_sig <= 1'b0;
end

//L^,\ύX񐔂JEg
always @ (posedge clk  )
  if (init_sig==1'b1)
     mem_cnt <= 8'd0;
  else if (mem_mode==1'b1)
    //L^[hłpush_swω+1
    if (rec_sig==1'b1)
      mem_cnt <= mem_cnt + 8'd1;
    else if(led_cnt == df_max)
    //led_cntdf_maxɂȂƕ\[hֈڍŝŃJE^ 
      mem_cnt <= 8'd0;
    else
      mem_cnt <= mem_cnt ;  
  else if (led_cnt== led_cnt_max)
   //\[hłled_cnt==led_cnt_maxɂȂꍇ+1
    mem_cnt <= mem_cnt + 8'd1;
  else if (led_cnt_max==32'hffffffff)
     mem_cnt <= 8'd0;
  else
    mem_cnt <= mem_cnt ;

//LED_^C~OJEg            
always @ (posedge clk  )
  if (init_sig == 1'b1)
    led_cnt <= 32'd0;
  else if (mem_mode==1'b1)
    //L^[hłpush_swω0
    if ((rec_sig==1'b1)||(led_cnt == df_max)) 
      led_cnt <= 32'b0;
    else
      led_cnt <= led_cnt + 32'd1;
  else if ((led_cnt >= led_cnt_max)||(led_cnt_max==32'hffffffff))
   //\[hłled_cnt==led_cnt_maxɂȂꍇ0
    led_cnt <= 32'b0;
  else 
    led_cnt <= led_cnt + 32'd1;
   
//LED䃌WX^ 
always @ (posedge clk  )
  if (init_sig ==1'b1) 
    led_0 <= 1'b1;
  else if(mem_mode==1'b1)
    if (rec_sig == 1'b1)
      led_0 <= ~led_0;
    else 
      led_0 <= led_0;
  else
    if ((led_cnt_max==32'd0)||(led_cnt == df_max))
      led_0 <= 1'b0;
    else if(led_cnt==led_cnt_max)
      led_0 <= ~led_0;
    else 
      led_0 <= led_0;
 

//   
assign mem_adr = ((mem_mode==1'b0)&&(led_cnt == led_cnt_max))?(mem_cnt + 8'd1):mem_cnt;

assign mem_we =((mem_mode==1'b1)&&(led_cnt == df_max))?1'b1:rec_sig;

assign mem_wd =((mem_mode==1'b1)&&(led_cnt == df_max))?32'hffffffff:led_cnt;
   
cmd_mem cmd_mem (
        .clka(clk),
        .wea(mem_we), // Bus [0 : 0] 
        .addra(mem_cnt), // Bus [7 : 0] 
        .dina(mem_wd), // Bus [31 : 0] 
        .clkb(clk),
        .addrb(mem_adr), // Bus [7 : 0] 
        .doutb(led_cnt_max)); // Bus [31 : 0]
   
endmodule






